Module javafx.graphics
Package javafx.scene.layout

# Class RowConstraints

java.lang.Object
javafx.scene.layout.ConstraintsBase
javafx.scene.layout.RowConstraints

public class RowConstraints extends ConstraintsBase
Defines optional layout constraints for a row in a `GridPane`. If a RowConstraints object is added for a row in a gridpane, the gridpane will use those constraint values when computing the row's height and layout.

For example, to create a GridPane with 10 rows 50 pixels tall:

         GridPane gridpane = new GridPane();
         for (int i = 0; i < 10; i++) {
             RowConstraints row = new RowConstraints(50);
             gridpane.getRowConstraints().add(row);
         }

Or, to create a GridPane where rows take 25%, 50%, 25% of its height:

         GridPane gridpane = new GridPane();
         RowConstraints row1 = new RowConstraints();
         row1.setPercentHeight(25);
         RowConstraints row2 = new RowConstraints();
         row2.setPercentHeight(50);
         RowConstraints row3 = new RowConstraints();
         row3.setPercentHeight(25);
         gridpane.getRowConstraints().addAll(row1,row2,row3);

Note that adding an empty RowConstraints object has the effect of not setting any constraints, leaving the GridPane to compute the row's layout based solely on its content's size preferences and constraints.

Since:
  JavaFX 2.0

- ## Property Summary

  Properties
  Type
  Property
  Description
  `final BooleanProperty`
  `fillHeight`
  The vertical fill policy for the row.
  `final DoubleProperty`
  `maxHeight`
  The maximum height for the row.
  `final DoubleProperty`
  `minHeight`
  The minimum height for the row.
  `final DoubleProperty`
  `percentHeight`
  The height percentage of the row.
  `final DoubleProperty`
  `prefHeight`
  The preferred height for the row.
  `final ObjectProperty<VPos>`
  `valignment`
  The vertical alignment for the row.
  `final ObjectProperty<Priority>`
  `vgrow`
  The vertical grow priority for the row.

- ## Field Summary

  ### Fields declared in class javafx.scene.layout.ConstraintsBase

  `CONSTRAIN_TO_PREF`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RowConstraints()`
  Creates a row constraints object with no properties set.
  `RowConstraints(double height)`
  Creates a row constraint object with a fixed height.
  `RowConstraints(double minHeight, double prefHeight, double maxHeight)`
  Creates a row constraint object with a fixed size range.
  `RowConstraints(double minHeight, double prefHeight, double maxHeight, Priority vgrow, VPos valignment, boolean fillHeight)`
  Creates a row constraint object with a fixed size range, vertical grow priority, vertical alignment, and vertical fill behavior.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final BooleanProperty`
  `fillHeightProperty()`
  The vertical fill policy for the row.
  `final double`
  `getMaxHeight()`
  Gets the value of the `maxHeight` property.
  `final double`
  `getMinHeight()`
  Gets the value of the `minHeight` property.
  `final double`
  `getPercentHeight()`
  Gets the value of the `percentHeight` property.
  `final double`
  `getPrefHeight()`
  Gets the value of the `prefHeight` property.
  `final VPos`
  `getValignment()`
  Gets the value of the `valignment` property.
  `final Priority`
  `getVgrow()`
  Gets the value of the `vgrow` property.
  `final boolean`
  `isFillHeight()`
  Gets the value of the `fillHeight` property.
  `final DoubleProperty`
  `maxHeightProperty()`
  The maximum height for the row.
  `final DoubleProperty`
  `minHeightProperty()`
  The minimum height for the row.
  `final DoubleProperty`
  `percentHeightProperty()`
  The height percentage of the row.
  `final DoubleProperty`
  `prefHeightProperty()`
  The preferred height for the row.
  `final void`
  `setFillHeight(boolean value)`
  Sets the value of the `fillHeight` property.
  `final void`
  `setMaxHeight(double value)`
  Sets the value of the `maxHeight` property.
  `final void`
  `setMinHeight(double value)`
  Sets the value of the `minHeight` property.
  `final void`
  `setPercentHeight(double value)`
  Sets the value of the `percentHeight` property.
  `final void`
  `setPrefHeight(double value)`
  Sets the value of the `prefHeight` property.
  `final void`
  `setValignment(VPos value)`
  Sets the value of the `valignment` property.
  `final void`
  `setVgrow(Priority value)`
  Sets the value of the `vgrow` property.
  `String`
  `toString()`
  Returns a string representation of this `RowConstraints` object.
  `final ObjectProperty<VPos>`
  `valignmentProperty()`
  The vertical alignment for the row.
  `final ObjectProperty<Priority>`
  `vgrowProperty()`
  The vertical grow priority for the row.

  ### Methods declared in class javafx.scene.layout.ConstraintsBase

  `requestLayout`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Property Details

  - ### minHeight

    public final DoubleProperty minHeightProperty
    The minimum height for the row. This property is ignored if percentHeight is set.

    The default value is USE_COMPUTED_SIZE, which means the minimum height will be computed to be the largest minimum height of the row's content.

    See Also:
      - `getMinHeight()`
      - `setMinHeight(double)`
      - `minHeightProperty()`

  - ### prefHeight

    public final DoubleProperty prefHeightProperty
    The preferred height for the row. This property is ignored if percentHeight is set.

    The default value is USE_COMPUTED_SIZE, which means the preferred height will be computed to be the largest preferred height of the row's content.

    See Also:
      - `getPrefHeight()`
      - `setPrefHeight(double)`
      - `prefHeightProperty()`

  - ### maxHeight

    public final DoubleProperty maxHeightProperty
    The maximum height for the row. This property is ignored if percentHeight is set.

    The default value is USE_COMPUTED_SIZE, which means the maximum height will be computed to be the smallest maximum height of the row's content.

    See Also:
      - `getMaxHeight()`
      - `setMaxHeight(double)`
      - `maxHeightProperty()`

  - ### percentHeight

    public final DoubleProperty percentHeightProperty
    The height percentage of the row. If set to a value greater than 0, the row will be resized to that percentage of the available gridpane height and the other size constraints (minHeight, prefHeight, maxHeight, vgrow) will be ignored. The default value is -1, which means the percentage will be ignored.
    See Also:
      - `getPercentHeight()`
      - `setPercentHeight(double)`
      - `percentHeightProperty()`

  - ### vgrow

    public final ObjectProperty<Priority> vgrowProperty
    The vertical grow priority for the row. If set, the gridpane will use this priority to determine whether the row should be given any additional height if the gridpane is resized larger than its preferred height. This property is ignored if percentHeight is set.

    This default value is null, which means that the row's grow priority will be derived from largest grow priority set on a content node.

    See Also:
      - `getVgrow()`
      - `setVgrow(Priority)`
      - `vgrowProperty()`

  - ### valignment

    public final ObjectProperty<VPos> valignmentProperty
    The vertical alignment for the row. If set, will be the default vertical alignment for nodes contained within the row. If this property is set to VPos.BASELINE, then the fillHeight property will be ignored and nodes will always be resized to their preferred heights.
    See Also:
      - `getValignment()`
      - `setValignment(VPos)`
      - `valignmentProperty()`

  - ### fillHeight

    public final BooleanProperty fillHeightProperty
    The vertical fill policy for the row. The gridpane will use this property to determine whether nodes contained within the row should be expanded to fill the row's height or kept to their preferred heights.

    The default value is true.

    See Also:
      - `isFillHeight()`
      - `setFillHeight(boolean)`
      - `fillHeightProperty()`

- ## Constructor Details

  - ### RowConstraints

    public RowConstraints()
    Creates a row constraints object with no properties set.

  - ### RowConstraints

    public RowConstraints(double height)
    Creates a row constraint object with a fixed height. This is a convenience for setting the preferred height constraint to the fixed value and the minHeight and maxHeight constraints to the USE_PREF_SIZE flag to ensure the row is always that height.
    Parameters:
      `height` - the height of the row

  - ### RowConstraints

    public RowConstraints(double minHeight, double prefHeight, double maxHeight)
    Creates a row constraint object with a fixed size range. This is a convenience for setting the minimum, preferred, and maximum height constraints.
    Parameters:
      `minHeight` - the minimum height
      `prefHeight` - the preferred height
      `maxHeight` - the maximum height

  - ### RowConstraints

    public RowConstraints(double minHeight, double prefHeight, double maxHeight, Priority vgrow, VPos valignment, boolean fillHeight)
    Creates a row constraint object with a fixed size range, vertical grow priority, vertical alignment, and vertical fill behavior.
    Parameters:
      `minHeight` - the minimum height
      `prefHeight` - the preferred height
      `maxHeight` - the maximum height
      `vgrow` - the vertical grow priority
      `valignment` - the vertical alignment
      `fillHeight` - the vertical fill behavior

- ## Method Details

  - ### setMinHeight

    public final void setMinHeight(double value)
    Sets the value of the `minHeight` property.
    Property description:
      The minimum height for the row. This property is ignored if percentHeight is set.

      The default value is USE_COMPUTED_SIZE, which means the minimum height will be computed to be the largest minimum height of the row's content.

    Parameters:
      `value` - the value for the `minHeight` property
    See Also:
      - `getMinHeight()`
      - `minHeightProperty()`

  - ### getMinHeight

    public final double getMinHeight()
    Gets the value of the `minHeight` property.
    Property description:
      The minimum height for the row. This property is ignored if percentHeight is set.

      The default value is USE_COMPUTED_SIZE, which means the minimum height will be computed to be the largest minimum height of the row's content.

    Returns:
      the value of the `minHeight` property
    See Also:
      - `setMinHeight(double)`
      - `minHeightProperty()`

  - ### minHeightProperty

    public final DoubleProperty minHeightProperty()
    The minimum height for the row. This property is ignored if percentHeight is set.

    The default value is USE_COMPUTED_SIZE, which means the minimum height will be computed to be the largest minimum height of the row's content.

    Returns:
      the `minHeight` property
    See Also:
      - `getMinHeight()`
      - `setMinHeight(double)`

  - ### setPrefHeight

    public final void setPrefHeight(double value)
    Sets the value of the `prefHeight` property.
    Property description:
      The preferred height for the row. This property is ignored if percentHeight is set.

      The default value is USE_COMPUTED_SIZE, which means the preferred height will be computed to be the largest preferred height of the row's content.

    Parameters:
      `value` - the value for the `prefHeight` property
    See Also:
      - `getPrefHeight()`
      - `prefHeightProperty()`

  - ### getPrefHeight

    public final double getPrefHeight()
    Gets the value of the `prefHeight` property.
    Property description:
      The preferred height for the row. This property is ignored if percentHeight is set.

      The default value is USE_COMPUTED_SIZE, which means the preferred height will be computed to be the largest preferred height of the row's content.

    Returns:
      the value of the `prefHeight` property
    See Also:
      - `setPrefHeight(double)`
      - `prefHeightProperty()`

  - ### prefHeightProperty

    public final DoubleProperty prefHeightProperty()
    The preferred height for the row. This property is ignored if percentHeight is set.

    The default value is USE_COMPUTED_SIZE, which means the preferred height will be computed to be the largest preferred height of the row's content.

    Returns:
      the `prefHeight` property
    See Also:
      - `getPrefHeight()`
      - `setPrefHeight(double)`

  - ### setMaxHeight

    public final void setMaxHeight(double value)
    Sets the value of the `maxHeight` property.
    Property description:
      The maximum height for the row. This property is ignored if percentHeight is set.

      The default value is USE_COMPUTED_SIZE, which means the maximum height will be computed to be the smallest maximum height of the row's content.

    Parameters:
      `value` - the value for the `maxHeight` property
    See Also:
      - `getMaxHeight()`
      - `maxHeightProperty()`

  - ### getMaxHeight

    public final double getMaxHeight()
    Gets the value of the `maxHeight` property.
    Property description:
      The maximum height for the row. This property is ignored if percentHeight is set.

      The default value is USE_COMPUTED_SIZE, which means the maximum height will be computed to be the smallest maximum height of the row's content.

    Returns:
      the value of the `maxHeight` property
    See Also:
      - `setMaxHeight(double)`
      - `maxHeightProperty()`

  - ### maxHeightProperty

    public final DoubleProperty maxHeightProperty()
    The maximum height for the row. This property is ignored if percentHeight is set.

    The default value is USE_COMPUTED_SIZE, which means the maximum height will be computed to be the smallest maximum height of the row's content.

    Returns:
      the `maxHeight` property
    See Also:
      - `getMaxHeight()`
      - `setMaxHeight(double)`

  - ### setPercentHeight

    public final void setPercentHeight(double value)
    Sets the value of the `percentHeight` property.
    Property description:
      The height percentage of the row. If set to a value greater than 0, the row will be resized to that percentage of the available gridpane height and the other size constraints (minHeight, prefHeight, maxHeight, vgrow) will be ignored. The default value is -1, which means the percentage will be ignored.
    Parameters:
      `value` - the value for the `percentHeight` property
    See Also:
      - `getPercentHeight()`
      - `percentHeightProperty()`

  - ### getPercentHeight

    public final double getPercentHeight()
    Gets the value of the `percentHeight` property.
    Property description:
      The height percentage of the row. If set to a value greater than 0, the row will be resized to that percentage of the available gridpane height and the other size constraints (minHeight, prefHeight, maxHeight, vgrow) will be ignored. The default value is -1, which means the percentage will be ignored.
    Returns:
      the value of the `percentHeight` property
    See Also:
      - `setPercentHeight(double)`
      - `percentHeightProperty()`

  - ### percentHeightProperty

    public final DoubleProperty percentHeightProperty()
    The height percentage of the row. If set to a value greater than 0, the row will be resized to that percentage of the available gridpane height and the other size constraints (minHeight, prefHeight, maxHeight, vgrow) will be ignored. The default value is -1, which means the percentage will be ignored.
    Returns:
      the `percentHeight` property
    See Also:
      - `getPercentHeight()`
      - `setPercentHeight(double)`

  - ### setVgrow

    public final void setVgrow(Priority value)
    Sets the value of the `vgrow` property.
    Property description:
      The vertical grow priority for the row. If set, the gridpane will use this priority to determine whether the row should be given any additional height if the gridpane is resized larger than its preferred height. This property is ignored if percentHeight is set.

      This default value is null, which means that the row's grow priority will be derived from largest grow priority set on a content node.

    Parameters:
      `value` - the value for the `vgrow` property
    See Also:
      - `getVgrow()`
      - `vgrowProperty()`

  - ### getVgrow

    public final Priority getVgrow()
    Gets the value of the `vgrow` property.
    Property description:
      The vertical grow priority for the row. If set, the gridpane will use this priority to determine whether the row should be given any additional height if the gridpane is resized larger than its preferred height. This property is ignored if percentHeight is set.

      This default value is null, which means that the row's grow priority will be derived from largest grow priority set on a content node.

    Returns:
      the value of the `vgrow` property
    See Also:
      - `setVgrow(Priority)`
      - `vgrowProperty()`

  - ### vgrowProperty

    public final ObjectProperty<Priority> vgrowProperty()
    The vertical grow priority for the row. If set, the gridpane will use this priority to determine whether the row should be given any additional height if the gridpane is resized larger than its preferred height. This property is ignored if percentHeight is set.

    This default value is null, which means that the row's grow priority will be derived from largest grow priority set on a content node.

    Returns:
      the `vgrow` property
    See Also:
      - `getVgrow()`
      - `setVgrow(Priority)`

  - ### setValignment

    public final void setValignment(VPos value)
    Sets the value of the `valignment` property.
    Property description:
      The vertical alignment for the row. If set, will be the default vertical alignment for nodes contained within the row. If this property is set to VPos.BASELINE, then the fillHeight property will be ignored and nodes will always be resized to their preferred heights.
    Parameters:
      `value` - the value for the `valignment` property
    See Also:
      - `getValignment()`
      - `valignmentProperty()`

  - ### getValignment

    public final VPos getValignment()
    Gets the value of the `valignment` property.
    Property description:
      The vertical alignment for the row. If set, will be the default vertical alignment for nodes contained within the row. If this property is set to VPos.BASELINE, then the fillHeight property will be ignored and nodes will always be resized to their preferred heights.
    Returns:
      the value of the `valignment` property
    See Also:
      - `setValignment(VPos)`
      - `valignmentProperty()`

  - ### valignmentProperty

    public final ObjectProperty<VPos> valignmentProperty()
    The vertical alignment for the row. If set, will be the default vertical alignment for nodes contained within the row. If this property is set to VPos.BASELINE, then the fillHeight property will be ignored and nodes will always be resized to their preferred heights.
    Returns:
      the `valignment` property
    See Also:
      - `getValignment()`
      - `setValignment(VPos)`

  - ### setFillHeight

    public final void setFillHeight(boolean value)
    Sets the value of the `fillHeight` property.
    Property description:
      The vertical fill policy for the row. The gridpane will use this property to determine whether nodes contained within the row should be expanded to fill the row's height or kept to their preferred heights.

      The default value is true.

    Parameters:
      `value` - the value for the `fillHeight` property
    See Also:
      - `isFillHeight()`
      - `fillHeightProperty()`

  - ### isFillHeight

    public final boolean isFillHeight()
    Gets the value of the `fillHeight` property.
    Property description:
      The vertical fill policy for the row. The gridpane will use this property to determine whether nodes contained within the row should be expanded to fill the row's height or kept to their preferred heights.

      The default value is true.

    Returns:
      the value of the `fillHeight` property
    See Also:
      - `setFillHeight(boolean)`
      - `fillHeightProperty()`

  - ### fillHeightProperty

    public final BooleanProperty fillHeightProperty()
    The vertical fill policy for the row. The gridpane will use this property to determine whether nodes contained within the row should be expanded to fill the row's height or kept to their preferred heights.

    The default value is true.

    Returns:
      the `fillHeight` property
    See Also:
      - `isFillHeight()`
      - `setFillHeight(boolean)`

  - ### toString

    public String toString()
    Returns a string representation of this `RowConstraints` object.
    Overrides:
      `toString` in class `Object`
    Returns:
      a string representation of this `RowConstraints` object.